aboutsummaryrefslogtreecommitdiff
path: root/libraries/qt5-legacy/qt5-legacy.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/qt5-legacy/qt5-legacy.SlackBuild')
-rw-r--r--libraries/qt5-legacy/qt5-legacy.SlackBuild280
1 files changed, 280 insertions, 0 deletions
diff --git a/libraries/qt5-legacy/qt5-legacy.SlackBuild b/libraries/qt5-legacy/qt5-legacy.SlackBuild
new file mode 100644
index 000000000000..8cca3c719b02
--- /dev/null
+++ b/libraries/qt5-legacy/qt5-legacy.SlackBuild
@@ -0,0 +1,280 @@
+#!/bin/sh
+
+# Slackware build script for qt5-legacy
+
+# Maintained 2018- by Dave Woodfall <dave@dawoodfall.net>
+# Copyright 2013-2017 Larry Hajali <larryhaja[at]gmail[dot]com>
+# Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Merged some ideas from Alex Sarmardzic's script for qt4 at SlackBuilds.org
+# ^^ Modified by Robby Workman <rworkman@slackware.com> for QT4 & KDE4
+
+# We're using qt-copy instead of a released qt version, as this git release
+# has at least one bugfix strongly recommended by the kde developers.
+
+# Obtained from:
+# git clone git://gitorious.org/+kde-developers/qt/kde-qt.git
+# git checkout origin/4.5.3-patched
+# git checkout origin/4.6.0-stable-patched
+# git checkout origin/4.6.1-patched
+# git checkout origin/4.7.0-patched
+#
+# Alternate method (we don't use this):
+# wget http://qt.gitorious.org/qt/kde-qt/archive-tarball/4.6.2-patched
+#
+# Modifications 2010, 2011, 2012 Eric Hameleers, Eindhoven, NL
+# qt 4.7.3, 4.7.4, 4.8.0, 4.8.1, 4.8.2, 4.8.4 are built from original nokia sources.
+
+# This is the highly modified version qt.SlackBuild found in Slackware
+# tailored to Qt 5. Modified by Larry Hajali.
+
+PRGNAM=qt5-legacy
+LIBNAM=qt5
+SRCNAM=qt-everywhere-opensource-src
+VERSION=${VERSION:-5.7.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ # To prevent "qatomic_armv6.h error: output number 2 not directly addressable"
+ # More permanent solution is to patch gcc:
+ # http://bazaar.launchpad.net/~linaro-toolchain-dev/gcc-linaro/4.6/revision/106731
+ SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16 -fno-strict-volatile-bitfields"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+# http://doc.qt.io/qt-5/qtwebengine-platform-notes.html#audio-and-video-codec-support
+PRCOD=""
+[ "$PROPRIETARY_CODECS" = "yes" ] && PRCOD="WEBENGINE_CONFIG += use_proprietary_codecs"
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.xz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Slackware patch to build against MySQL/MariaDB.
+patch -p1 < $CWD/patches/qt5.mysql.h.diff
+
+# Patch for the newer mozilla-nss
+patch -p1 < $CWD/patches/nss-update-sslv3-nonce.patch
+
+# Limit -reduce-relocations to ix86 and x86_64.
+# https://bugreports.qt-project.org/browse/QTBUG-36129
+if echo $ARCH | grep -q '\(i.86\|x86_64\)' 2>/dev/null; then
+ RELOCATIONS="-reduce-relocations"
+else
+ RELOCATIONS=""
+fi
+
+sed -i "s|-O2|$SLKCFLAGS|" qtbase/mkspecs/common/gcc-base.conf
+
+# Build examples. Default is no.
+if [ "${EXAMPLES:-no}" == "yes" ]; then
+ BUILD_EXAMPLES=""
+else
+ BUILD_EXAMPLES="-nomake examples"
+fi
+
+echo "$PRCOD" >> qtwebengine/.qmake.conf
+
+export CFLAGS="$SLKCFLAGS"
+export CXXFLAGS="$SLKCFLAGS"
+./configure -v \
+ -confirm-license \
+ -opensource \
+ -prefix "/usr/lib${LIBDIRSUFFIX}/$LIBNAM" \
+ -sysconfdir "/etc/xdg" \
+ -headerdir "/usr/include/$LIBNAM" \
+ -libdir "/usr/lib${LIBDIRSUFFIX}" \
+ -docdir "/usr/doc/$PRGNAM-$VERSION" \
+ -system-libpng \
+ -system-libjpeg \
+ -system-zlib \
+ -system-sqlite \
+ -system-pcre \
+ -plugin-sql-sqlite \
+ -icu \
+ -openssl \
+ -verbose \
+ -optimized-qmake \
+ -dbus-linked \
+ -qpa xcb \
+ -xcb \
+ -glib \
+ -accessibility \
+ -no-separate-debug-info \
+ -no-pch \
+ -no-rpath \
+ -no-strip \
+ -release \
+ -no-use-gold-linker \
+ -pulseaudio \
+ $RELOCATIONS \
+ $BUILD_EXAMPLES
+
+make
+make install INSTALL_ROOT=$PKG
+
+# Install documentation. Default is not to install documentation.
+if [ "${DOCS:-no}" == "yes" ]; then
+ # Recreate Makefiles in order to use the just compiled qdoc.
+ for doc in $(find . -name "Makefile*" | xargs egrep "^\s/usr/lib${LIBDIRSUFFIX}/qt5/bin/" \
+ | cut -d':' -f1 | uniq)
+ do
+ rm -fv $doc
+ done
+ make docs
+ make install_docs INSTALL_ROOT=$PKG
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+ln -s $LIBNAM $PKG/usr/lib${LIBDIRSUFFIX}/qt-$VERSION
+
+mkdir -p $PKG/usr/bin
+for BIN in $PKG/usr/lib${LIBDIRSUFFIX}/$LIBNAM/bin/*; do
+ TMP_FILE=$(echo $BIN | sed -e "s|$PKG||")
+ case $(basename $BIN) in
+ syncqt.pl|fixqt4headers.pl)
+ ln -s $TMP_FILE $PKG/usr/bin/$(basename $BIN)
+ ;;
+ *)
+ ln -s $TMP_FILE $PKG/usr/bin/$(basename $BIN)-$LIBNAM
+ ;;
+ esac
+done
+
+# Create Environment variables
+mkdir -p $PKG/etc/profile.d
+sed -e "s|@LIBDIRSUFFIX@|${LIBDIRSUFFIX}|g" $CWD/profile.d/$LIBNAM.sh \
+ > $PKG/etc/profile.d/$LIBNAM.sh
+sed -e "s|@LIBDIRSUFFIX@|${LIBDIRSUFFIX}|g" $CWD/profile.d/$LIBNAM.csh \
+ > $PKG/etc/profile.d/$LIBNAM.csh
+chmod 0755 $PKG/etc/profile.d/*
+
+cat > $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig/Qt5.pc << EOF
+prefix=/usr/lib${LIBDIRSUFFIX}/$LIBNAM
+bindir=\${prefix}/bin
+datadir=\${prefix}
+docdir=/usr/doc/$PRGNAM-$VERSION
+archdatadir=\${prefix}
+examplesdir=\${prefix}/examples
+headerdir=/usr/include/$LIBNAM
+importdir=\${prefix}/imports
+qmldir=\${prefix}/qml
+libdir=/usr/lib${LIBDIRSUFFIX}
+libexec=\${prefix}/libexec
+moc=\${bindir}/moc
+plugindir=\${prefix}/plugins
+qmake=\${bindir}/qmake
+sysconfdir=/etc/xdg
+translationdir=\${prefix}/translations
+
+Name: Qt5
+Description: Qt5 Configuration
+Version: $VERSION
+EOF
+
+# Fix internal linking for Qt5WebEngineCore.pc.
+sed -i \
+ -e 's|-Wl,--start-group.* -Wl,--end-group||' \
+ -e "s|-L${PWD}/qtwebengine/src/core/api/Release||" \
+ $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig/Qt5WebEngineCore.pc
+
+# While we are at it, there isn't any reason to keep references to $PKG in the *.prl files.
+for PRL in $(find $PKG -name "*\.prl"); do
+ sed -i '/^QMAKE_PRL_BUILD_DIR/d' $PRL
+done
+
+# One more for the road.
+sed -i "s|$PWD/qtbase|/usr/lib${LIBDIRSUFFIX}/$LIBNAM|" \
+ $PKG/usr/lib${LIBDIRSUFFIX}/$LIBNAM/mkspecs/modules/qt_lib_bootstrap_private.pri
+
+sed -i "s|-L${PWD}/\w*/lib ||g" \
+ $PKG/usr/lib${LIBDIRSUFFIX}/libqgsttools_p.prl
+
+for i in $CWD/desktop/*.desktop; do
+ install -D -m 0644 $i $PKG/usr/share/applications/$(basename $i)
+done
+sed -i "s|@LIBDIR@|$LIBDIRSUFFIX|" $PKG/usr/share/applications/*
+
+install -D -m 0644 qttools/src/assistant/assistant/images/assistant-128.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/assistant-qt5.png
+install -D -m 0644 qttools/src/designer/src/designer/images/designer.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/designer-qt5.png
+install -D -m 0644 qttools/src/qdbus/qdbusviewer/images/qdbusviewer-128.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/qdbusviewer-qt5.png
+for i in 16 32 48 64 128; do
+ install -D -m 0644 qttools/src/linguist/linguist/images/icons/linguist-${i}-32.png \
+ $PKG/usr/share/icons/hicolor/${i}x${i}/apps/linguist-qt5.png
+done
+
+# Remove executable bits from files.
+find $PKG \( -name "*.qml" -o -name "*.app" \) -perm 755 -exec chmod 644 '{}' \;
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ README qtbase/{header*,LGPL_EXCEPTION.txt,LICENSE.*L} \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}